/*
This code is part of the ImageMaker software (www.gerd-tentler.de/tools/imagemaker), copyright by
Gerd Tentler. Obtain permission before selling this code or hosting it on a commercial website or
redistributing it over the Internet or in any other medium. In all cases copyright must remain intact.

===========================================================================================================
 This script was tested with the following systems and browsers:

 - Windows Vista: Internet Explorer 8, Opera 9, Firefox 3, Chrome 4

 If you use another browser or system, this script may not work for you - sorry.
===========================================================================================================
*/

var _imo = new Array();
var imMouseX, imMouseY, imWinX, imWinY, imScrLeft, imScrTop, i;
var imFonts = new Array('arial', 'avalon', 'comic', 'corsiva', 'courier', 'digital', 'floralies',
                        'futura', 'germanica', 'herakles', 'impact', 'signpainter', 'square', 'times');
var imDlgBGColor = 'E0E0E0';
var imIcons = imWebPath + '/icons';

function IMAGEMAKER() {
//---------------------------------------------------------------------------------------------------------
// Configuration (don't change - can be adapted in config.inc.php!)
//---------------------------------------------------------------------------------------------------------
  this.editorBGColor = imEditorBGColor;     // editor background color
  this.editorBorder = imEditorBorder;       // editor border (CSS-spec: "size style color")
  this.editorFont = imEditorFont;           // editor font (CSS-spec: "style size family")

  this.imgWidth = imImgWidth;               // image width (pixels)
  this.imgHeight = imImgHeight;             // image height (pixels)
  this.imgBGColor = imImgBGColor;           // image background color (RGB hexcode, e.g. "FFA080")

  this.lineColor = imLineColor;             // line color (RGB hexcode, e.g. "FFA080")
  this.fillColor = imFillColor;             // fill color (RGB hexcode, e.g. "FFA080")
  this.text = imMsgText;                    // default text (can be adapted in language file)

//---------------------------------------------------------------------------------------------------------
// Functions
//---------------------------------------------------------------------------------------------------------
  this.id = 0;
  this.oid = 0;
  this.object = new Array();
  this.newObject = false;

  this.new_object = function(id, type, width, height, lineColor, fillColor, text) {
    this.object[id] = new Object();
    this.object[id].type = type;
    this.object[id].width = width;
    this.object[id].height = height;
    this.object[id].lineColor = lineColor;
    this.object[id].fillColor = fillColor;
    this.object[id].hAlign = 'center';
    this.object[id].vAlign = 'center';
    this.object[id].lMargin = 0;
    this.object[id].rMargin = 0;
    this.object[id].tMargin = 0;
    this.object[id].bMargin = 0;
    this.object[id].rotation = 0;
    this.object[id].opacity = 100;
    this.object[id].text = text;
  }

  this.init_dialog = function(dlg) {
    switch(dlg) {
      case 'ImgSize':
        document.imFrmImgSize.width.value = this.imgWidth;
        document.imFrmImgSize.height.value = this.imgHeight;
        break;
      case 'Object':
        document.imFrmObject.object.options[this.oid].selected = true;
        break;
      case 'Margins':
        document.imFrmMargins.left.value = this.object[this.oid].lMargin;
        document.imFrmMargins.right.value = this.object[this.oid].rMargin;
        document.imFrmMargins.top.value = this.object[this.oid].tMargin;
        document.imFrmMargins.bottom.value = this.object[this.oid].bMargin;
        break;
      case 'Font':
        var f = document.imFrmFont;
        var type = this.object[this.oid].type.split(/:/);
        for(var i = 0; i < f.font.length; i++) {
          if(f.font.options[i].value == type[1]) {
            f.font.options[i].selected = true;
            break;
          }
        }
        document.imFrmFont.size.value = this.object[this.oid].width;
        break;
      case 'Sizes':
        document.imFrmSizes.width.value = this.object[this.oid].width;
        document.imFrmSizes.height.value = this.object[this.oid].height;
        break;
      case 'SizesFile':
        document.imFrmSizesFile.width.value = this.object[this.oid].width;
        document.imFrmSizesFile.height.value = this.object[this.oid].height;
        document.imFrmSizesFile.file.value = this.object[this.oid].text;
        break;
      case 'Rotation':
        document.imFrmRotation.angle.value = this.object[this.oid].rotation;
        break;
      case 'Opacity':
        document.imFrmOpacity.opacity.options[this.object[this.oid].opacity / 10].selected = true;
        break;
    }
  }

  this.build_preview_link = function() {
    var objects = '';
    for(var i = cnt = 0; i < this.object.length; i++) {
      if(this.object[i].type) {
        if(objects) objects += '&';
        objects += 'object[' + cnt + ']=' +
                  this.object[i].type + '|' +
                  this.object[i].width + ';' + this.object[i].height + ';1|' +
                  this.object[i].lineColor + ';' + this.object[i].fillColor + '|' +
                  this.object[i].hAlign + ';' + this.object[i].vAlign + '|' +
                  this.object[i].lMargin + ';' + this.object[i].rMargin + ';' + this.object[i].tMargin + ';' + this.object[i].bMargin + '|' +
                  this.object[i].rotation + '|' +
                  this.object[i].opacity + '|' +
                  escape(this.object[i].text);
        cnt++;
      }
    }
    return imWebPath + '/imagemaker_create.php?width=' + this.imgWidth + '&height=' + this.imgHeight + '&color=' + this.imgBGColor + '&' + objects;
  }

  this.update_color_box = function(obj, type, color) {
    if(color) {
      obj.innerHTML = '<img src="' + imIcons + '/' + type + 'color.gif" width="14" height="14">';
      obj.style.backgroundColor = '#' + color;
    }
    else {
      obj.innerHTML = '<img src="' + imIcons + '/nocolor.gif" width="14" height="14">';
      obj.style.backgroundColor = 'buttonface';
    }
  }

  this.update = function() {
    if(document.images) {
      var link = this.build_preview_link();
      var type = this.object[this.oid].type.split(/:/);

      document.images['imPreview'+this.id].src = link;
      document.imFrmFont.text.value = this.object[this.oid].text;

      var obj = im_get_obj('imDivImgSize' + this.id);
      obj.innerHTML = '<b>' +
                      '<img src="' + imIcons + '/width.gif" width="14" height="14">' + this.imgWidth + ' &nbsp; ' +
                      '<img src="' + imIcons + '/height.gif" width="14" height="14">' + this.imgHeight +
                      '</b>';

      obj = im_get_obj('imDivObject' + this.id);
      obj.innerHTML = '<b>' + this.oid + '</b>';

      obj = im_get_obj('imDivImgBGColor' + this.id);
      this.update_color_box(obj, 'fill', this.imgBGColor);
      obj = im_get_obj('imDivLineColor' + this.id);
      this.update_color_box(obj, 'line', this.object[this.oid].lineColor);
      obj = im_get_obj('imDivFillColor' + this.id);
      this.update_color_box(obj, 'fill', this.object[this.oid].fillColor);

      obj = im_get_obj('imDivOpacity' + this.id);
      obj.innerHTML = '<b>' +
                      '<img src="' + imIcons + '/opacity.gif" width="14" height="14">' + this.object[this.oid].opacity +
                      '</b>';

      obj = im_get_obj('imDivMargins' + this.id);
      obj.innerHTML = '<b>' +
                      '<img src="' + imIcons + '/lmargin.gif" width="14" height="14">' + this.object[this.oid].lMargin + ' &nbsp; ' +
                      '<img src="' + imIcons + '/rmargin.gif" width="14" height="14">' + this.object[this.oid].rMargin + ' &nbsp; ' +
                      '<img src="' + imIcons + '/tmargin.gif" width="14" height="14">' + this.object[this.oid].tMargin + ' &nbsp; ' +
                      '<img src="' + imIcons + '/bmargin.gif" width="14" height="14">' + this.object[this.oid].bMargin +
                      '</b>';

      obj = im_get_obj('imDivRotation' + this.id);
      obj.innerHTML = '<b>' +
                      '<img src="' + imIcons + '/rotation.gif" width="14" height="14">' + this.object[this.oid].rotation +
                      '</b>';

      obj = im_get_obj('imDivTypeAttr' + this.id);
      if(type[0] == 'text') obj.innerHTML = '<b>' + type[1].toUpperCase() + ' / ' + this.object[this.oid].width + '</b>';
      else {
        obj.innerHTML = '<b>' +
                        '<img src="' + imIcons + '/width.gif" width="14" height="14">' + this.object[this.oid].width + ' &nbsp; ' +
                        '<img src="' + imIcons + '/height.gif" width="14" height="14">' + this.object[this.oid].height +
                        '</b>';
      }

      var icon = (type[0] == 'poly') ? type[0] + type[1] : type[0];
      document.images['imType'+this.id].src = imIcons + '/' + icon + '.gif';

      document.images['imHleft'+this.id].src = imIcons + '/hleft.gif';
      document.images['imHcenter'+this.id].src = imIcons + '/hcenter.gif';
      document.images['imHright'+this.id].src = imIcons + '/hright.gif';
      document.images['imVtop'+this.id].src = imIcons + '/vtop.gif';
      document.images['imVcenter'+this.id].src = imIcons + '/vcenter.gif';
      document.images['imVbottom'+this.id].src = imIcons + '/vbottom.gif';
      document.images['imH'+this.object[this.oid].hAlign+this.id].src = imIcons + '/h' + this.object[this.oid].hAlign + '_a.gif';
      document.images['imV'+this.object[this.oid].vAlign+this.id].src = imIcons + '/v' + this.object[this.oid].vAlign + '_a.gif';
    }
  }

  this.delete_object = function(id) {
    var obj = im_get_obj('imDlgObject');
    if(obj) obj.style.visibility = 'hidden';
    if(id) {
      obj = document.imFrmObject.object;
      obj.options[id] = null;
      for(var i = id; i < obj.length; i++) {
        txt = obj.options[i].text.split(/ /);
        obj.options[i].text = txt[0] - 1 + ' ' + txt[1];
      }
      this.object.splice(id, 1);
      this.oid = id - 1;
      this.update();
    }
    else alert("Object 0 can not be deleted!");
  }

  this.set_color = function(type, color) {
    var obj = im_get_obj('imDlg' + type);
    if(obj) obj.style.visibility = 'hidden';
    if(type == 'ImgBGColor') this.imgBGColor = color;
    else if(type == 'FillColor') this.object[this.oid].fillColor = color;
    else if(type == 'LineColor') this.object[this.oid].lineColor = color;
    this.update();
  }

  this.set_img_size = function(width, height) {
    var obj = im_get_obj('imDlgImgSize');
    if(obj) obj.style.visibility = 'hidden';
    this.imgWidth = width;
    this.imgHeight = height;
    this.update();
  }

  this.set_align = function(type, align) {
    if(type == 'H') this.object[this.oid].hAlign = align;
    else if(type == 'V') this.object[this.oid].vAlign = align;
    this.update();
  }

  this.set_margins = function(left, right, top, bottom) {
    var obj = im_get_obj('imDlgMargins');
    if(obj) obj.style.visibility = 'hidden';
    this.object[this.oid].lMargin = left;
    this.object[this.oid].rMargin = right;
    this.object[this.oid].tMargin = top;
    this.object[this.oid].bMargin = bottom;
    this.update();
  }

  this.set_rotation = function(angle) {
    var obj = im_get_obj('imDlgRotation');
    if(obj) obj.style.visibility = 'hidden';
    this.object[this.oid].rotation = angle;
    this.update();
  }

  this.set_opacity = function(opacity) {
    var obj = im_get_obj('imDlgOpacity');
    if(obj) obj.style.visibility = 'hidden';
    this.object[this.oid].opacity = opacity;
    this.update();
  }

  this.set_obj_id = function(object) {
    var obj = im_get_obj('imDlgObject');
    if(obj) obj.style.visibility = 'hidden';
    if(object != null) {
      this.oid = object;
      this.update();
    }
    else {
      this.newObject = true;
      im_view_dialog('Type', this.id);
    }
  }

  this.set_obj_type = function(type) {
    var obj = im_get_obj('imDlgType');
    if(obj) obj.style.visibility = 'hidden';
    if(this.newObject) {
      this.oid = document.imFrmObject.object.length;
      this.new_object(this.oid, '', 0, 0, this.lineColor, this.fillColor, '');
      var newEntry = new Option(this.oid);
      document.imFrmObject.object[this.oid] = newEntry;
      this.newObject = false;
    }
    document.imFrmObject.object.options[this.oid].text = this.oid + ' ' + type;
    if(type == 'text') {
      type = 'text:' + imFonts[0];
      this.object[this.oid].width = Math.round(this.imgHeight / 5);
      this.object[this.oid].text = this.text;
    }
    else {
      this.object[this.oid].width = Math.round(this.imgWidth / 2);
      this.object[this.oid].height = Math.round(this.imgHeight / 2);
      this.object[this.oid].text = '';
    }
    this.object[this.oid].type = type;
    this.update();
  }

  this.set_obj_size = function(width, height) {
    var obj = im_get_obj('imDlgSizes');
    if(obj) obj.style.visibility = 'hidden';
    if(width) this.object[this.oid].width = width;
    if(height) this.object[this.oid].height = height;
    this.update();
  }

  this.set_obj_size_file = function(width, height, file) {
    var obj = im_get_obj('imDlgSizesFile');
    if(obj) obj.style.visibility = 'hidden';
    if(width) this.object[this.oid].width = width;
    if(height) this.object[this.oid].height = height;
    if(file) this.object[this.oid].text = file;
    this.update();
  }

  this.set_font = function(font, size, text) {
    var obj = im_get_obj('imDlgFont');
    if(obj) obj.style.visibility = 'hidden';
    if(font) this.object[this.oid].type = 'text:' + font;
    if(size) this.object[this.oid].width = size;
    this.object[this.oid].text = text;
    this.update();
  }

  this.view_properties = function() {
    var type = this.object[this.oid].type;
    if(type == 'ellipse' || type.indexOf('poly') != -1) im_view_dialog('Sizes', this.id);
    else if(type == 'image') im_view_dialog('SizesFile', this.id);
    else im_view_dialog('Font', this.id);
  }

  this.cancel_type = function() {
    this.newObject = false;
    im_view_dialog('Type');
  }

  this.create = function() {
    this.id = _imo.length;
    if(_imo[this.id] = this) {
      this.new_object(0, 'text:' + imFonts[0], Math.round(this.imgHeight / 5), 0, this.lineColor, this.fillColor, this.text);
      document.imFrmFont.text.value = this.object[this.oid].text;

      document.writeln('<table border="0" cellspacing="2" cellpadding="4" width="' + this.imgWidth + '"><tr>' +
                       '<td style="background-color:' + this.editorBGColor + '; border:' + this.editorBorder + '; font:' + this.editorFont + '">');

      // image size, background color, object number
      document.writeln('<table border="0" cellspacing="0" cellpadding="0" class="imToolBar"><tr align="center">' +
                       '<td class="imBtnBar" width="100" title="' + imMsgImgSize + '"' +
                       ' onMouseOver="this.className=\'imRaised\'; window.status=\'' + imMsgImgSize + '\'; return true"' +
                       ' onMouseOut="this.className=\'imBtnBar\'; window.status=\'\'"' +
                       ' onMouseDown="this.className=\'imPressed\'"' +
                       ' onMouseUp="this.className=\'imRaised\'"' +
                       ' onClick="im_view_dialog(\'ImgSize\', ' + this.id + ')">' +
                       '<div id="imDivImgSize' + this.id + '" style="white-space:nowrap; font:' + this.editorFont + '"></div></td>' +
                       '<td width="5" align="center"><div style="width:0px; height:16px; border:1px inset #FFFFFF"></div></td>' +
                       '<td class="imBtnBar" width="29" title="' + imMsgBGColor + '"' +
                       ' onMouseOver="this.className=\'imRaised\'; window.status=\'' + imMsgBGColor + '\'; return true"' +
                       ' onMouseOut="this.className=\'imBtnBar\'; window.status=\'\'"' +
                       ' onMouseDown="this.className=\'imPressed\'"' +
                       ' onMouseUp="this.className=\'imRaised\'"' +
                       ' onClick="im_view_dialog(\'ImgBGColor\', ' + this.id + ')">' +
                       '<div id="imDivImgBGColor' + this.id + '" style="width:14px; height:14px; border:1px inset #FFFFFF"></div></td>' +
                       '<td width="5" align="center"><div style="width:0px; height:16px; border:1px inset #FFFFFF"></div></td>' +
                       '<td class="imBtnBar" width="29" title="' + imMsgObject + '"' +
                       ' onMouseOver="this.className=\'imRaised\'; window.status=\'' + imMsgObject + '\'; return true"' +
                       ' onMouseOut="this.className=\'imBtnBar\'; window.status=\'\'"' +
                       ' onMouseDown="this.className=\'imPressed\'"' +
                       ' onMouseUp="this.className=\'imRaised\'"' +
                       ' onClick="im_view_dialog(\'Object\', ' + this.id + ')">' +
                       '<div id="imDivObject' + this.id + '" style="font:' + this.editorFont + '"></div></td>' +
                       '</tr></table>');

      // object type, properties, line color, fill color, opacity
      document.writeln('<table border="0" cellspacing="0" cellpadding="0" class="imToolBar"><tr align="center">' +
                       '<td class="imBtnBar" width="25" title="' + imMsgType + '"' +
                       ' onMouseOver="this.className=\'imRaised\'; window.status=\'' + imMsgType + '\'; return true"' +
                       ' onMouseOut="this.className=\'imBtnBar\'; window.status=\'\'"' +
                       ' onMouseDown="this.className=\'imPressed\'"' +
                       ' onMouseUp="this.className=\'imRaised\'"' +
                       ' onClick="im_view_dialog(\'Type\', ' + this.id + ')">' +
                       '<img src="' + imIcons + '/text.gif" name="imType' + this.id + '" width="16" height="16"></td>' +
                       '<td width="5" align="center"><div style="width:0px; height:16px; border:1px inset #FFFFFF"></div></td>' +
                       '<td class="imBtnBar" width="100" title="' + imgMsgProperties + '"' +
                       ' onMouseOver="this.className=\'imRaised\'; window.status=\'' + imgMsgProperties + '\'; return true"' +
                       ' onMouseOut="this.className=\'imBtnBar\'; window.status=\'\'"' +
                       ' onMouseDown="this.className=\'imPressed\'"' +
                       ' onMouseUp="this.className=\'imRaised\'"' +
                       ' onClick="_imo[' + this.id + '].view_properties()">' +
                       '<div id="imDivTypeAttr' + this.id + '" style="white-space:nowrap; font:' + this.editorFont + '"></div></td>' +
                       '<td width="5" align="center"><div style="width:0px; height:16px; border:1px inset #FFFFFF"></div></td>' +
                       '<td class="imBtnBar" width="20" title="' + imMsgLineColor + '"' +
                       ' onMouseOver="this.className=\'imRaised\'; window.status=\'' + imMsgLineColor + '\'; return true"' +
                       ' onMouseOut="this.className=\'imBtnBar\'; window.status=\'\'"' +
                       ' onMouseDown="this.className=\'imPressed\'"' +
                       ' onMouseUp="this.className=\'imRaised\'"' +
                       ' onClick="im_view_dialog(\'LineColor\', ' + this.id + ')">' +
                       '<div id="imDivLineColor' + this.id + '" style="width:14px; height:14px; border:1px inset #FFFFFF"></div></td>' +
                       '<td width="5" align="center"><div style="width:0px; height:16px; border:1px inset #FFFFFF"></div></td>' +
                       '<td class="imBtnBar" width="20" title="' + imMsgFillColor + '"' +
                       ' onMouseOver="this.className=\'imRaised\'; window.status=\'' + imMsgFillColor + '\'; return true"' +
                       ' onMouseOut="this.className=\'imBtnBar\'; window.status=\'\'"' +
                       ' onMouseDown="this.className=\'imPressed\'"' +
                       ' onMouseUp="this.className=\'imRaised\'"' +
                       ' onClick="im_view_dialog(\'FillColor\', ' + this.id + ')">' +
                       '<div id="imDivFillColor' + this.id + '" style="width:14px; height:14px; border:1px inset #FFFFFF"></div></td>' +
                       '<td width="5" align="center"><div style="width:0px; height:16px; border:1px inset #FFFFFF"></div></td>' +
                       '<td class="imBtnBar" width="50" title="' + imMsgOpacity + '"' +
                       ' onMouseOver="this.className=\'imRaised\'; window.status=\'' + imMsgOpacity + '\'; return true"' +
                       ' onMouseOut="this.className=\'imBtnBar\'; window.status=\'\'"' +
                       ' onMouseDown="this.className=\'imPressed\'"' +
                       ' onMouseUp="this.className=\'imRaised\'"' +
                       ' onClick="im_view_dialog(\'Opacity\', ' + this.id + ')">' +
                       '<div id="imDivOpacity' + this.id + '" style="width:50px; font:' + this.editorFont + '"></div></td>' +
                       '</tr></table>');

      // margins
      document.writeln('<table border="0" cellspacing="0" cellpadding="0" class="imToolBar"><tr align="center">' +
                       '<td class="imBtnBar" width="180" title="' + imMsgMargins + '"' +
                       ' onMouseOver="this.className=\'imRaised\'; window.status=\'' + imMsgMargins + '\'; return true"' +
                       ' onMouseOut="this.className=\'imBtnBar\'; window.status=\'\'"' +
                       ' onMouseDown="this.className=\'imPressed\'"' +
                       ' onMouseUp="this.className=\'imRaised\'"' +
                       ' onClick="im_view_dialog(\'Margins\', ' + this.id + ')" style="width:180px">' +
                       '<div id="imDivMargins' + this.id + '" style="width:180px; white-space:nowrap; font:' + this.editorFont + '"></div></td>' +
                       '</tr></table>');

      // alignment, rotation
      document.writeln('<table border="0" cellspacing="0" cellpadding="0" class="imToolBar"><tr align="center">' +
                       '<td class="imBtnBar" width="20" title="' + imMsgJLeft + '"' +
                       ' onMouseOver="this.className=\'imRaised\'; window.status=\'' + imMsgJLeft + '\'; return true"' +
                       ' onMouseOut="this.className=\'imBtnBar\'; window.status=\'\'"' +
                       ' onMouseDown="this.className=\'imPressed\'"' +
                       ' onMouseUp="this.className=\'imRaised\'"' +
                       ' onClick="_imo[' + this.id + '].set_align(\'H\', \'left\')">' +
                       '<img src="' + imIcons + '/hleft.gif" name="imHleft' + this.id + '" width="16" height="16"></td>' +
                       '<td class="imBtnBar" width="20" title="' + imMsgJCenter + '"' +
                       ' onMouseOver="this.className=\'imRaised\'; window.status=\'' + imMsgJCenter + '\'; return true"' +
                       ' onMouseOut="this.className=\'imBtnBar\'; window.status=\'\'"' +
                       ' onMouseDown="this.className=\'imPressed\'"' +
                       ' onMouseUp="this.className=\'imRaised\'"' +
                       ' onClick="_imo[' + this.id + '].set_align(\'H\', \'center\')">' +
                       '<img src="' + imIcons + '/hcenter.gif" name="imHcenter' + this.id + '" width="16" height="16"></td>' +
                       '<td class="imBtnBar" width="20" title="' + imMsgJRight + '"' +
                       ' onMouseOver="this.className=\'imRaised\'; window.status=\'' + imMsgJRight + '\'; return true"' +
                       ' onMouseOut="this.className=\'imBtnBar\'; window.status=\'\'"' +
                       ' onMouseDown="this.className=\'imPressed\'"' +
                       ' onMouseUp="this.className=\'imRaised\'"' +
                       ' onClick="_imo[' + this.id + '].set_align(\'H\', \'right\')">' +
                       '<img src="' + imIcons + '/hright.gif" name="imHright' + this.id + '" width="16" height="16"></td>' +
                       '<td width="5" align="center"><div style="width:0px; height:16px; border:1px inset #FFFFFF"></div></td>' +
                       '<td class="imBtnBar" width="20" title="' + imMsgTop + '"' +
                       ' onMouseOver="this.className=\'imRaised\'; window.status=\'' + imMsgTop + '\'; return true"' +
                       ' onMouseOut="this.className=\'imBtnBar\'; window.status=\'\'"' +
                       ' onMouseDown="this.className=\'imPressed\'"' +
                       ' onMouseUp="this.className=\'imRaised\'"' +
                       ' onClick="_imo[' + this.id + '].set_align(\'V\', \'top\')">' +
                       '<img src="' + imIcons + '/vtop.gif" name="imVtop' + this.id + '" width="16" height="16"></td>' +
                       '<td class="imBtnBar" width="20" title="' + imMsgMiddle + '"' +
                       ' onMouseOver="this.className=\'imRaised\'; window.status=\'' + imMsgMiddle + '\'; return true"' +
                       ' onMouseOut="this.className=\'imBtnBar\'; window.status=\'\'"' +
                       ' onMouseDown="this.className=\'imPressed\'"' +
                       ' onMouseUp="this.className=\'imRaised\'"' +
                       ' onClick="_imo[' + this.id + '].set_align(\'V\', \'center\')">' +
                       '<img src="' + imIcons + '/vcenter.gif" name="imVcenter' + this.id + '" width="16" height="16"></td>' +
                       '<td class="imBtnBar" width="20" title="' + imMsgBottom + '"' +
                       ' onMouseOver="this.className=\'imRaised\'; window.status=\'' + imMsgBottom + '\'; return true"' +
                       ' onMouseOut="this.className=\'imBtnBar\'; window.status=\'\'"' +
                       ' onMouseDown="this.className=\'imPressed\'"' +
                       ' onMouseUp="this.className=\'imRaised\'"' +
                       ' onClick="_imo[' + this.id + '].set_align(\'V\', \'bottom\')">' +
                       '<img src="' + imIcons + '/vbottom.gif" name="imVbottom' + this.id + '" width="16" height="16"></td>' +
                       '<td width="5" align="center"><div style="width:0px; height:16px; border:1px inset #FFFFFF"></div></td>' +
                       '<td class="imBtnBar" width="50" title="' + imMsgRotation + '"' +
                       ' onMouseOver="this.className=\'imRaised\'; window.status=\'' + imMsgRotation + '\'; return true"' +
                       ' onMouseOut="this.className=\'imBtnBar\'; window.status=\'\'"' +
                       ' onMouseDown="this.className=\'imPressed\'"' +
                       ' onMouseUp="this.className=\'imRaised\'"' +
                       ' onClick="im_view_dialog(\'Rotation\', ' + this.id + ')">' +
                       '<div id="imDivRotation' + this.id + '" style="width:50px; font:' + this.editorFont + '"></div></td>' +
                       '</tr></table>');

      // preview
      document.writeln('<br><img name="imPreview' + this.id + '" src="' + imWebPath + '/imagemaker_create.php" border="0">' +
                       '</td>' +
                       '</tr></table>');
      this.update();
    }
    else alert("Could not create image builder!");
  }
}

//---------------------------------------------------------------------------------------------------------
// Global functions
//---------------------------------------------------------------------------------------------------------
function im_color_chart(type) {
  var c = new Array();
  // red
  c[0] = new Array('FFEEEE', 'FFCCCC', 'FFAAAA', 'FF8888', 'FF6666', 'FF4444', 'FF2222', 'FF0000',
                   'EE0000', 'CC0000', 'AA0000', '880000', '770000', '660000', '550000', '440000', '330000');
  // green
  c[1] = new Array('EEFFEE', 'CCFFCC', 'AAFFAA', '88FF88', '66FF66', '44FF44', '22FF22', '00FF00',
                   '00EE00', '00CC00', '00AA00', '008800', '007700', '006600', '005500', '004400', '003300');
  // blue
  c[2] = new Array('EEEEFF', 'CCCCFF', 'AAAAFF', '8888FF', '6666FF', '4444FF', '2222FF', '0000FF',
                   '0000EE', '0000CC', '0000AA', '000088', '000077', '000066', '000055', '000044', '000033');
  // yellow
  c[3] = new Array('FFFFEE', 'FFFFCC', 'FFFFAA', 'FFFF88', 'FFFF66', 'FFFF44', 'FFFF22', 'FFFF00',
                   'EEEE00', 'CCCC00', 'AAAA00', '888800', '777700', '666600', '555500', '444400', '333300');
  // pink
  c[4] = new Array('FFEEFF', 'FFCCFF', 'FFAAFF', 'FF88FF', 'FF66FF', 'FF44FF', 'FF22FF', 'FF00FF',
                   'EE00EE', 'CC00CC', 'AA00AA', '880088', '770077', '660066', '550055', '440044', '330033');
  // brown
  c[5] = new Array('FFF0D0', 'FFEECC', 'FFEEBB', 'FFDDAA', 'FFCC99', 'FFC090', 'EEBB88', 'DDAA77',
                   'CC9966', 'BB8855', 'AA7744', '886633', '775522', '664411', '553300', '442200', '331100');
  // cyan
  c[6] = new Array('EEFFFF', 'CCFFFF', 'AAFFFF', '88FFFF', '66FFFF', '44FFFF', '22FFFF', '00FFFF',
                   '00EEEE', '00CCCC', '00AAAA', '008888', '007777', '006666', '005555', '004444', '003333');
  // grey
  c[7] = new Array('',       'FFFFFF', 'EEEEEE', 'DDDDDD', 'CCCCCC', 'BBBBBB', 'AAAAAA', '999999',
                   '888888', '777777', '666666', '555555', '444444', '333333', '222222', '111111', '000001');

  var html = '<table border="0" cellspacing="1" cellpadding="0" bgcolor="#808080">';
  var style, title, i, j;

  for(i = 0; i < c.length; i++) {
    html += '<tr>';

    for(j = 0; j < c[i].length; j++) {
      title = c[i][j] ? '#'+ c[i][j] : imMsgNone;
      if(c[i][j]) style = '<div style="width:14px; height:14px; font-size:1px; cursor:hand; background-color:#' + c[i][j] + ';"></div>';
      else style = '<img src="' + imIcons + '/nocolor.gif" border="0" width="14" height="14">';
      html += '<td width="14" height="14" bgcolor="#' + (c[i][j] ? c[i][j] : imDlgBGColor) + '">' +
              '<a href="javascript:_imo[document.imFrm' + type + '.id.value].set_color(\'' + type + '\', \'' + c[i][j] + '\')" ' +
              'title="' + title + '">' + style + '</a></td>';
    }
    html += '</tr>';
  }
  html += '</table>';
  return html;
}

function im_get_obj(id) {
  var obj = false;
  if(document.getElementById) obj = document.getElementById(id);
  else if(document.all) obj = document.all[id];
  return obj;
}

function im_get_scrollLeft() {
  var scrLeft = 0;
  if(document.documentElement && document.documentElement.scrollLeft)
    scrLeft = document.documentElement.scrollLeft;
  else if(document.body && document.body.scrollLeft)
    scrLeft = document.body.scrollLeft;
  else if(window.pageXOffset) scrLeft = window.pageXOffset;
  return scrLeft;
}

function im_get_scrollTop() {
  var scrTop = 0;
  if(document.documentElement && document.documentElement.scrollTop)
    scrTop = document.documentElement.scrollTop;
  else if(document.body && document.body.scrollTop)
    scrTop = document.body.scrollTop;
  else if(window.pageYOffset) scrTop = window.pageYOffset;
  return scrTop;
}

function im_get_win_xy() {
  if(window.innerWidth) {
    imWinX = window.innerWidth;
    imWinY = window.innerHeight;
  }
  else if(document.documentElement && document.documentElement.offsetWidth) {
    imWinX = document.documentElement.offsetWidth;
    imWinY = document.documentElement.offsetHeight;
  }
  else if(document.body && document.body.offsetWidth) {
    imWinX = document.body.offsetWidth;
    imWinY = document.body.offsetHeight;
  }
  else {
    imWinX = screen.width;
    imWinY = screen.height;
  }
  imScrLeft = im_get_scrollLeft();
  imScrTop = im_get_scrollTop();
}

function im_view_dialog(dlg, id) {
  if(id != null) {
    _imo[id].init_dialog(dlg);
    document.forms['imFrm'+dlg].id.value = id;
  }

  var obj = im_get_obj('imDlg' + dlg);
  if(obj) {
    if(obj.style.visibility == 'visible') obj.style.visibility = 'hidden';
    else {
      var obj2;
      var d = new Array('ImgBGColor', 'LineColor', 'FillColor', 'Sizes', 'SizesFile',
                        'Font', 'Type', 'ImgSize', 'Object', 'Margins', 'Rotation', 'Opacity');

      for(var i = 0; i < d.length; i++) {
        obj2 = im_get_obj('imDlg' + d[i]);
        obj2.style.visibility = 'hidden';
      }

      var wdth = hght = 0;
      var top = imMouseY;
      var left = imMouseX;

      if(document.getElementById) {
        wdth = obj.offsetWidth;
        hght = obj.offsetHeight;
      }
      else if(obj.style.pixelWidth) {
        wdth = obj.style.pixelWidth;
        hght = obj.style.pixelHeight;
      }

      im_get_win_xy();
      if(left + wdth - imScrLeft > imWinX) left = imWinX + imScrLeft - wdth;
      if(top + hght - imScrTop > imWinY) top = imWinY + imScrTop - hght - 20;

      obj.style.left = (left - 50) + 'px';
      obj.style.top = top + 'px';
      obj.style.visibility = 'visible';

      if(document.forms['imFrm'+dlg].elements.length > 2) document.forms['imFrm'+dlg].elements[1].focus();
    }
  }
}

function im_get_mouse_xy(e) {
  if(e && e.pageX) {
    imMouseX = e.pageX;
    imMouseY = e.pageY;
  }
  else if(typeof event != 'undefined') {
    imMouseX = event.clientX + im_get_scrollLeft();
    imMouseY = event.clientY + im_get_scrollTop();
  }
}

document.onmouseup = im_get_mouse_xy;

//---------------------------------------------------------------------------------------------------------
// Global styles / dialog boxes
//---------------------------------------------------------------------------------------------------------
document.writeln('<style> ' +
                 '.imForm { ' +
                 'margin: 0px; ' +
                 'padding: 4px; ' +
                 'border: 2px groove #FFFFFF; ' +
                 '} ' +
                 '.imDialog { ' +
                 'position: absolute; ' +
                 'padding: 4px; ' +
                 'z-index: 69; ' +
                 'background-color: #' + imDlgBGColor + '; ' +
                 'border: 2px groove #FFFFFF; ' +
                 'white-space: nowrap; ' +
                 'text-align: center; ' +
                 'visibility: hidden; ' +
                 '} ' +
                 '.imFont1 { ' +
                 'font-family: Verdana, Arial, Helvetica; ' +
                 'font-size: 12px; ' +
                 'font-weight: bold; ' +
                 'margin-top: 0px; ' +
                 'margin-bottom: 4px; ' +
                 'padding: 2px; ' +
                 'background-color: #F0F0F0; ' +
                 'border: 2px groove #FFFFFF; ' +
                 'white-space: nowrap; ' +
                 'text-align: center; ' +
                 '} ' +
                 '.imFont2 { ' +
                 'font-family: Verdana, Arial, Helvetica; ' +
                 'font-size: 11px; ' +
                 'text-align: center; ' +
                 '} ' +
                 '.imFormField { ' +
                 'font-family: Courier New, Courier, Monospace; ' +
                 'font-size: 12px; ' +
                 'border: 2px groove #FFFFFF; ' +
                 '} ' +
                 '.imButton { ' +
                 'font-family: Verdana, Arial, Helvetica; ' +
                 'font-size: 11px; ' +
                 'font-weight: bold; ' +
                 'width: 100px; ' +
                 'margin-top: 4px; ' +
                 'background-color: #D0D0D0; ' +
                 '} ' +
                 '.imToolBar { ' +
                 'margin: 0px 4px 4px 0px; ' +
                 'padding: 0px; ' +
                 'float: left; ' +
                 'height: 26px; ' +
                 'background: buttonface; ' +
                 'border-top: 1px solid buttonhighlight; ' +
                 'border-left: 1px solid buttonhighlight; ' +
                 'border-bottom: 1px solid buttonshadow; ' +
                 'border-right: 1px solid buttonshadow; ' +
                 'cursor: default; ' +
                 '} ' +
                 '.imBtnBar { ' +
                 'background: buttonface; ' +
                 'border: 1px solid buttonface; ' +
                 'padding: 2px; ' +
                 'cursor: default; ' +
                 '} ' +
                 '.imRaised { ' +
                 'border-top: 1px solid buttonhighlight; ' +
                 'border-left: 1px solid buttonhighlight; ' +
                 'border-bottom: 1px solid buttonshadow; ' +
                 'border-right: 1px solid buttonshadow; ' +
                 'background: buttonface; ' +
                 'padding: 2px; ' +
                 'cursor: default; ' +
                 '} ' +
                 '.imPressed { ' +
                 'border-top: 1px solid buttonshadow; ' +
                 'border-left: 1px solid buttonshadow; ' +
                 'border-bottom: 1px solid buttonhighlight; ' +
                 'border-right: 1px solid buttonhighlight; ' +
                 'background: buttonface; ' +
                 'padding-left: 3px; ' +
                 'padding-top: 3px; ' +
                 'padding-bottom: 1px; ' +
                 'padding-right: 1px; ' +
                 'cursor: default; ' +
                 '} ' +
                 '</style>');

document.writeln('<div id="imDlgImgSize" class="imDialog"><center>' +
                 '<p class="imFont1">' + imMsgImgSize + '</p>' +
                 '<form name="imFrmImgSize" class="imForm">' +
                 '<input type="hidden" name="id" value="">' +
                 '<span class="imFont2">' +
                 imMsgWidth + ': <input type="text" name="width" size="3" maxlength="3" class="imFormField"> &nbsp; ' +
                 imMsgHeight + ': <input type="text" name="height" size="3" maxlength="3" class="imFormField"><br>' +
                 '<input type="button" value="' + imMsgCancel + '" class="imButton" onClick="im_view_dialog(\'ImgSize\')"> &nbsp; ' +
                 '<input type="button" value="OK" class="imButton"' +
                 ' onClick="_imo[document.imFrmImgSize.id.value].set_img_size(document.imFrmImgSize.width.value, document.imFrmImgSize.height.value)">' +
                 '</span>' +
                 '</form>' +
                 '</center></div>');

document.writeln('<div id="imDlgImgBGColor" class="imDialog"><center>' +
                 '<p class="imFont1">' + imMsgBGColor + '</p>' +
                 '<form name="imFrmImgBGColor" class="imForm">' +
                 '<input type="hidden" name="id" value="">' +
                 im_color_chart('ImgBGColor') +
                 '<input type="button" value="' + imMsgCancel + '" class="imButton" onClick="im_view_dialog(\'ImgBGColor\')">' +
                 '</form>' +
                 '</center></div>');

document.writeln('<div id="imDlgObject" class="imDialog"><center>' +
                 '<p class="imFont1">' + imMsgObject + '</p>' +
                 '<form name="imFrmObject" class="imForm">' +
                 '<input type="hidden" name="id" value="">' +
                 '<span class="imFont2">' + imMsgObject + ' ID: ' +
                 '<select name="object" class="imFormField">' +
                 '<option>0 text</select> &nbsp; ' +
                 '[<a href="javascript:_imo[document.imFrmObject.id.value].delete_object(document.imFrmObject.object.selectedIndex)">' +
                 imMsgDelete + '</a>] &nbsp; ' +
                 '[<a href="javascript:_imo[document.imFrmObject.id.value].set_obj_id()">' +
                 imMsgNew + '</a>]<br>' +
                 '<input type="button" value="' + imMsgCancel + '" class="imButton" onClick="im_view_dialog(\'Object\')"> &nbsp; ' +
                 '<input type="button" value="OK" class="imButton"' +
                 ' onClick="_imo[document.imFrmObject.id.value].set_obj_id(document.imFrmObject.object.selectedIndex)">' +
                 '</span>' +
                 '</form>' +
                 '</center></div>');

document.writeln('<div id="imDlgLineColor" class="imDialog"><center>' +
                 '<p class="imFont1">' + imMsgLineColor + '</p>' +
                 '<form name="imFrmLineColor" class="imForm">' +
                 '<input type="hidden" name="id" value="">' +
                 im_color_chart('LineColor') +
                 '<input type="button" value="' + imMsgCancel + '" class="imButton" onClick="im_view_dialog(\'LineColor\')">' +
                 '</form>' +
                 '</center></div>');

document.writeln('<div id="imDlgFillColor" class="imDialog"><center>' +
                 '<p class="imFont1">' + imMsgFillColor + '</p>' +
                 '<form name="imFrmFillColor" class="imForm">' +
                 '<input type="hidden" name="id" value="">' +
                 im_color_chart('FillColor') +
                 '<input type="button" value="' + imMsgCancel + '" class="imButton" onClick="im_view_dialog(\'FillColor\')">' +
                 '</form>' +
                 '</center></div>');

document.writeln('<div id="imDlgFont" class="imDialog"><center>' +
                 '<p class="imFont1">' + imgMsgProperties + '</p>' +
                 '<form name="imFrmFont" class="imForm">' +
                 '<input type="hidden" name="id" value="">' +
                 '<table border="0" cellspacing="0" cellpadding="0" width="280"><tr>' +
                 '<td class="imFont2" align="left" style="text-align:left">' +
                 imMsgFont + ': <select name="font" class="imFormField">');
                 for(i = 0; i < imFonts.length; i++) {
                   document.writeln('<option value="' + imFonts[i] + '">' + imFonts[i].toUpperCase());
                 }
                 document.writeln('</select></td>' +
                 '<td class="imFont2" align="right" style="text-align:right">' +
                 imMsgSize + ': <input type="text" name="size" size="2" maxlength="2" class="imFormField"></td>' +
                 '</tr></table>' +
                 '<textarea name="text" wrap="virtual" class="imFormField" style="width:280px; height:60px"></textarea><br>' +
                 '<input type="button" value="' + imMsgCancel + '" class="imButton" onClick="im_view_dialog(\'Font\')"> &nbsp; ' +
                 '<input type="button" value="OK" class="imButton"' +
                 ' onClick="_imo[document.imFrmFont.id.value].set_font(document.imFrmFont.font.value, document.imFrmFont.size.value, document.imFrmFont.text.value)">' +
                 '</span>' +
                 '</form>' +
                 '</center></div>');

document.writeln('<div id="imDlgSizes" class="imDialog"><center>' +
                 '<p class="imFont1">' + imgMsgProperties + '</p>' +
                 '<form name="imFrmSizes" class="imForm">' +
                 '<input type="hidden" name="id" value="">' +
                 '<span class="imFont2">' +
                 imMsgWidth + ': <input type="text" name="width" size="3" maxlength="3" class="imFormField"> &nbsp; ' +
                 imMsgHeight + ': <input type="text" name="height" size="3" maxlength="3" class="imFormField"><br>' +
                 '<input type="button" value="' + imMsgCancel + '" class="imButton" onClick="im_view_dialog(\'Sizes\')"> &nbsp; ' +
                 '<input type="button" value="OK" class="imButton"' +
                 ' onClick="_imo[document.imFrmSizes.id.value].set_obj_size(document.imFrmSizes.width.value, document.imFrmSizes.height.value)">' +
                 '</span>' +
                 '</form>' +
                 '</center></div>');

document.writeln('<div id="imDlgSizesFile" class="imDialog"><center>' +
                 '<p class="imFont1">' + imgMsgProperties + '</p>' +
                 '<form name="imFrmSizesFile" class="imForm">' +
                 '<input type="hidden" name="id" value="">' +
                 '<span class="imFont2">' +
                 imMsgWidth + ': <input type="text" name="width" size="3" maxlength="3" class="imFormField"> &nbsp; ' +
                 imMsgHeight + ': <input type="text" name="height" size="3" maxlength="3" class="imFormField"><br>' +
                 imMsgFile + ': <input type="text" name="file" size="25" maxlength="100" class="imFormField"><br>' +
                 '<input type="button" value="' + imMsgCancel + '" class="imButton" onClick="im_view_dialog(\'SizesFile\')"> &nbsp; ' +
                 '<input type="button" value="OK" class="imButton"' +
                 ' onClick="_imo[document.imFrmSizesFile.id.value].set_obj_size_file(document.imFrmSizesFile.width.value, document.imFrmSizesFile.height.value, document.imFrmSizesFile.file.value)">' +
                 '</span>' +
                 '</form>' +
                 '</center></div>');

document.writeln('<div id="imDlgMargins" class="imDialog"><center>' +
                 '<p class="imFont1">' + imMsgMargins + '</p>' +
                 '<form name="imFrmMargins" class="imForm">' +
                 '<input type="hidden" name="id" value="">' +
                 '<span class="imFont2">' +
                 imMsgLeft + ': <input type="text" name="left" size="3" maxlength="3" class="imFormField"> &nbsp; ' +
                 imMsgRight + ': <input type="text" name="right" size="3" maxlength="3" class="imFormField"> &nbsp; ' +
                 imMsgTop + ': <input type="text" name="top" size="3" maxlength="3" class="imFormField"> &nbsp; ' +
                 imMsgBottom + ': <input type="text" name="bottom" size="3" maxlength="3" class="imFormField"><br>' +
                 '<input type="button" value="' + imMsgCancel + '" class="imButton" onClick="im_view_dialog(\'Margins\')"> &nbsp; ' +
                 '<input type="button" value="OK" class="imButton"' +
                 ' onClick="_imo[document.imFrmMargins.id.value].set_margins(document.imFrmMargins.left.value, document.imFrmMargins.right.value, document.imFrmMargins.top.value, document.imFrmMargins.bottom.value)">' +
                 '</span>' +
                 '</form>' +
                 '</center></div>');

document.writeln('<div id="imDlgType" class="imDialog"><center>' +
                 '<p class="imFont1">' + imMsgType + '</p>' +
                 '<form name="imFrmType" class="imForm">' +
                 '<input type="hidden" name="id" value="">' +
                 '<table border="0" cellspacing="2" cellpadding="4" class="imToolBar"><tr align="center">' +
                 '<td class="imBtnBar" width="20" title="' + imMsgText + '"' +
                 ' onMouseOver="this.className=\'imRaised\'; window.status=\'' + imMsgText + '\'; return true"' +
                 ' onMouseOut="this.className=\'imBtnBar\'; window.status=\'\'"' +
                 ' onMouseDown="this.className=\'imPressed\'"' +
                 ' onClick="_imo[document.imFrmType.id.value].set_obj_type(\'text\')">' +
                 '<img src="' + imIcons + '/text.gif" border="0" width="16" height="16"></td>' +
                 '<td class="imBtnBar" width="20" title="' + imMsgEllipse + '"' +
                 ' onMouseOver="this.className=\'imRaised\'; window.status=\'' + imMsgEllipse + '\'; return true"' +
                 ' onMouseOut="this.className=\'imBtnBar\'; window.status=\'\'"' +
                 ' onMouseDown="this.className=\'imPressed\'"' +
                 ' onClick="_imo[document.imFrmType.id.value].set_obj_type(\'ellipse\')">' +
                 '<img src="' + imIcons + '/ellipse.gif" border="0" width="16" height="16"></td>' +
                 '<td class="imBtnBar" width="20" title="' + imMsgTriangle + '"' +
                 ' onMouseOver="this.className=\'imRaised\'; window.status=\'' + imMsgTriangle + '\'; return true"' +
                 ' onMouseOut="this.className=\'imBtnBar\'; window.status=\'\'"' +
                 ' onMouseDown="this.className=\'imPressed\'"' +
                 ' onClick="_imo[document.imFrmType.id.value].set_obj_type(\'poly:3\')">' +
                 '<img src="' + imIcons + '/poly3.gif" border="0" width="16" height="16"></td>' +
                 '<td class="imBtnBar" width="20" title="' + imMsgRectangle + '"' +
                 ' onMouseOver="this.className=\'imRaised\'; window.status=\'' + imMsgRectangle + '\'; return true"' +
                 ' onMouseOut="this.className=\'imBtnBar\'; window.status=\'\'"' +
                 ' onMouseDown="this.className=\'imPressed\'"' +
                 ' onClick="_imo[document.imFrmType.id.value].set_obj_type(\'poly:4\')">' +
                 '<img src="' + imIcons + '/poly4.gif" border="0" width="16" height="16"></td>' +
                 '<td class="imBtnBar" width="20" title="' + imMsgImage + '"' +
                 ' onMouseOver="this.className=\'imRaised\'; window.status=\'' + imMsgImage + '\'; return true"' +
                 ' onMouseOut="this.className=\'imBtnBar\'; window.status=\'\'"' +
                 ' onMouseDown="this.className=\'imPressed\'"' +
                 ' onClick="_imo[document.imFrmType.id.value].set_obj_type(\'image\')">' +
                 '<img src="' + imIcons + '/image.gif" border="0" width="16" height="16"></td>' +
                 '</tr></table>' +
                 '<input type="button" value="' + imMsgCancel + '" class="imButton" onClick="_imo[document.imFrmType.id.value].cancel_type()">' +
                 '</form>' +
                 '</center></div>');

document.writeln('<div id="imDlgRotation" class="imDialog"><center>' +
                 '<p class="imFont1">' + imMsgRotation + '</p>' +
                 '<form name="imFrmRotation" class="imForm">' +
                 '<input type="hidden" name="id" value="">' +
                 '<span class="imFont2">' +
                 imMsgAngle + ': <input type="text" name="angle" size="3" class="imFormField"><br>' +
                 '<input type="button" value="' + imMsgCancel + '" class="imButton" onClick="im_view_dialog(\'Rotation\')"> &nbsp; ' +
                 '<input type="button" value="OK" class="imButton"' +
                 ' onClick="_imo[document.imFrmRotation.id.value].set_rotation(document.imFrmRotation.angle.value)">' +
                 '</span>' +
                 '</form>' +
                 '</center></div>');

document.writeln('<div id="imDlgOpacity" class="imDialog"><center>' +
                 '<p class="imFont1">' + imMsgOpacity + '</p>' +
                 '<form name="imFrmOpacity" class="imForm">' +
                 '<input type="hidden" name="id" value="">' +
                 '<span class="imFont2">' +
                 '<select name="opacity" class="imFormField">');
                 for(i = 0; i <= 100; i += 10) document.writeln('<option value="' + i + '">' + i);
                 document.writeln('</select><br>' +
                 '<input type="button" value="' + imMsgCancel + '" class="imButton" onClick="im_view_dialog(\'Opacity\')"> &nbsp; ' +
                 '<input type="button" value="OK" class="imButton"' +
                 ' onClick="_imo[document.imFrmOpacity.id.value].set_opacity(document.imFrmOpacity.opacity.options[document.imFrmOpacity.opacity.selectedIndex].value)">' +
                 '</span>' +
                 '</form>' +
                 '</center></div>');

//---------------------------------------------------------------------------------------------------------
